about summary refs log tree commit diff
path: root/scripts/nix-push-prebuilts
diff options
context:
space:
mode:
authorEelco Dolstra <e.dolstra@tudelft.nl>2003-05-25T22·42+0000
committerEelco Dolstra <e.dolstra@tudelft.nl>2003-05-25T22·42+0000
commit7dd91d3779b4f806ac0085e0ccc60416d81c1148 (patch)
treee4c5f7e8d8978df671050fae0c25639cca79e251 /scripts/nix-push-prebuilts
parent0ef4b6d0f8dcaec093e3db366b6dfb6ba47f73a6 (diff)
* Prebuilt package sharing. We allow transparent binary deployment by
  sharing package directories (i.e., the result of building a Nix
  descriptor).

  `nix-pull-prebuilts' obtains a list of all known prebuilts by
  consulting the paths and URLs specified in
  $prefix/etc/nix/prebuilts.conf.  The mappings ($pkghash,
  $prebuilthash) and ($prebuilthash, $location) are registered with
  Nix so that it can use the prebuilt with hash $prebuilthash when
  installing a package with hash $pkghash by downloading and unpacking
  $location.

  `nix-push-prebuilts' creates prebuilts for all packages for which no
  prebuilt is known to exist.  It can then optionally upload these
  to the network through rsync.

  `nix-[pull|push]-prebuilts' just provide a policy.  Nix provides the
  mechanism through the `nix [export|regprebuilt|regurl]' commands.


Diffstat (limited to 'scripts/nix-push-prebuilts')
-rwxr-xr-xscripts/nix-push-prebuilts40
1 files changed, 40 insertions, 0 deletions
diff --git a/scripts/nix-push-prebuilts b/scripts/nix-push-prebuilts
new file mode 100755
index 000000000000..2e3029b1699f
--- /dev/null
+++ b/scripts/nix-push-prebuilts
@@ -0,0 +1,40 @@
+#! /usr/bin/perl -w
+
+my $prefix = $ENV{"NIX"} || "/nix"; # !!! use prefix
+my $etcdir = "$prefix/etc/nix";
+my $exportdir = "$prefix/var/nix/prebuilts/exports";
+my $knowns = "$prefix/var/nix/known-prebuilts";
+
+# For performance, put the known hashes in an associative array.
+my %knowns = ();
+open KNOWNS, "<$knowns";
+while (<KNOWNS>) {
+    next unless /([0-9a-z]{32})/;
+    $knowns{$1} = 1;
+}
+close KNOWNS;
+
+# For each installed package, check whether a prebuilt is known.
+
+open PKGS, "nix listinst|";
+open KNOWNS, ">>$knowns";
+
+while (<PKGS>) {
+    chomp;
+    next unless /([0-9a-z]{32})/;
+    my $pkghash = $1;
+    if (!defined $knowns{$1}) {
+        # No known prebuilt exists for this package; so export it.
+        print "exporting $pkghash...\n";
+        system "nix export '$exportdir' $pkghash";
+        if ($?) { die "`nix export' failed"; }
+        print KNOWNS "$pkghash\n";
+    }
+}
+
+close KNOWNS;
+close PKGS;
+
+# Push the prebuilts to the server. !!! FIXME
+
+system "rsync -av -e ssh '$exportdir' losser:/home/eelco/public_html/nix-prebuilts/";